<template>
    <div v-if="suivi">
        <InformationsGenerales :utilisateur="eleve" v-if="eleve" />
        <div class="uk-grid ">
            <Conseils
                :conseils="suivi.conseils"
                :eleveId="eleve.id"
                :modifiable="true"
            />
            <InformationSuivi :suivi="suivi" v-if="suivi" />
        </div>

        <h3 class="uk-heading-line"><span>Nouvelles cartes en erreur</span></h3>
        <ListeProblemes :problemes="nouvellesCartesEnErreur" />

        <h3 class="uk-heading-line"><span>Erreurs fréquentes</span></h3>
        <ListeProblemes :problemes="erreursRegulieres" />

        <div>
            <button
                class="uk-button uk-button-default uk-align-right uk-margin-small-top"
                @click="repondreQuestion()"
            >
                Résoudre
            </button>
        </div>
        <h3 class="uk-heading-line">
            <span>Problèmes avec une question</span>
        </h3>
        <ListeProblemes
            :problemes="problemesAvecQuestion"
            :avecSelection="true"
            @prendreEnCompteProbleme="prendreEnCompteProbleme"
        />
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import InformationsGenerales from '@/views/Compte/InformationsGenerales.vue';
import ListeProblemes from '@/components/ListeProblemes.vue';
import Conseils from './Conseils.vue';
import InformationSuivi from './InformationSuivi.vue';
import Axios from '@/auth/axiosAuth';
import { Prop } from 'vue-property-decorator';

@Component({
    components: {
        InformationsGenerales,
        ListeProblemes,
        Conseils,
        InformationSuivi
    }
})
export default class DetailEleve extends Vue {
    @Prop() id: number;
    private suivi: any[] = [];
    private eleve: Record<string, any>;
    private nouvellesCartesEnErreur = {};
    private erreursRegulieres = {};
    private problemesAvecQuestion: any[] = [];
    private problemesCoches: any[] = [];
    private conseils: any[] = [];

    beforeRouteEnter(to, from, next) {
        next(vm => {
            const formdata = new FormData();
            formdata.append('idClub', vm.$auth.user.idClub);
            formdata.append('idEleve', to.params.id);
            Axios.post(
                'suivieleve/eleve/',
                response => {
                    vm.suivi = response.data;
                    vm.eleve = vm.suivi.eleve;
                    vm.nouvellesCartesEnErreur = vm.suivi.nouvellesCartesEnErreur.map(
                        carte => carte.probleme
                    );
                    vm.erreursRegulieres = vm.suivi.erreursRegulieres.map(
                        carte => carte.probleme
                    );
                    vm.problemesAvecQuestion = vm.suivi.problemesAvecQuestion.map(
                        carte => carte.probleme
                    );
                },
                formdata
            );
        });
    }

    public prendreEnCompteProbleme(problemesCoches) {
        this.problemesCoches = problemesCoches;
    }

    public repondreQuestion() {
        const formData = new FormData();
        this.problemesCoches.forEach(id => formData.append('problemesIds', id));
        formData.append('eleveId', this.eleve.id);
        formData.append('professeurId', this.$auth.user.id);
        Axios.post(
            'suivieleve/',
            () => {
                this.problemesAvecQuestion = this.problemesAvecQuestion.filter(
                    element => !this.problemesCoches.includes(element.id)
                );
                this.problemesCoches = [];
            },
            formData
        );
    }
}
</script>
